using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;

namespace NotesLib
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	[ToolboxItem(true)]
	public class NotesPanel : System.Windows.Forms.Panel
	{
		private System.Windows.Forms.Panel buttonPanel;
		private System.Windows.Forms.Button showAllNotesBT;
		private System.Windows.Forms.Button showUserNotesBT;
		private System.Windows.Forms.Button addNoteBT;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid notesDBG;
		private bool buttonPanelVisible;

		public NotesPanel()
		{
			InitializeComponent();

			this.ButtonPanelVisible = true;

			Console.WriteLine("Panel loc = " + this.Location+", size=" + this.Size);
		}
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		#region Initialize the panel
		private void InitializeComponent()
		{
			this.buttonPanel = new System.Windows.Forms.Panel();
			this.showAllNotesBT = new System.Windows.Forms.Button();
			this.showUserNotesBT = new System.Windows.Forms.Button();
			this.addNoteBT = new System.Windows.Forms.Button();
			this.notesDBG = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.SuspendLayout();
			this.buttonPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.notesDBG)).BeginInit();
			// 
			// buttonPanel
			// 
			this.buttonPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.buttonPanel.Controls.Add(this.showAllNotesBT);
			this.buttonPanel.Controls.Add(this.showUserNotesBT);
			this.buttonPanel.Controls.Add(this.addNoteBT);
			this.buttonPanel.Location = new System.Drawing.Point(0, 0);
			this.buttonPanel.Name = "buttonPanel";
			this.buttonPanel.Size = new System.Drawing.Size(480, 40);
			this.buttonPanel.TabIndex = 0;
			// 
			// showAllNotesBT
			// 
			this.showAllNotesBT.Location = new System.Drawing.Point(8, 8);
			this.showAllNotesBT.Name = "showAllNotesBT";
			this.showAllNotesBT.TabIndex = 0;
			this.showAllNotesBT.Text = "Show All";
			// 
			// showUserNotesBT
			// 
			this.showUserNotesBT.Location = new System.Drawing.Point(88, 8);
			this.showUserNotesBT.Name = "showUserNotesBT";
			this.showUserNotesBT.Size = new System.Drawing.Size(120, 23);
			this.showUserNotesBT.TabIndex = 1;
			this.showUserNotesBT.Text = "Show User Notes";
			// 
			// addNoteBT
			// 
			this.addNoteBT.Location = new System.Drawing.Point(216, 8);
			this.addNoteBT.Name = "addNoteBT";
			this.addNoteBT.TabIndex = 2;
			this.addNoteBT.Text = "Add Note";
			this.addNoteBT.Click += new EventHandler(addNoteBT_Click);
			// 
			// notesDBG
			// 
			this.notesDBG.AllowDragSelectedCols = true;
			this.notesDBG.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.notesDBG.Location = new System.Drawing.Point(0, 40);
			this.notesDBG.Name = "notesDBG";
			this.notesDBG.OptimizeInsertRemoveCells = true;
			this.notesDBG.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.notesDBG.Size = new System.Drawing.Size(472, 296);
			this.notesDBG.SmartSizeBox = false;
			this.notesDBG.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.notesDBG.TabIndex = 1;
			this.notesDBG.Text = "notesDBG";
			this.notesDBG.UseListChangedEvent = true;

			this.Controls.Add(this.notesDBG);
			this.Controls.Add(this.buttonPanel);
			((System.ComponentModel.ISupportInitialize)(this.notesDBG)).EndInit();
			this.buttonPanel.ResumeLayout(false);
			this.ResumeLayout(false);
		}
		#endregion

		#region Properties
		/// <summary>
		/// Specifies whether or not to show a button panel.
		/// </summary>
		[
		DefaultValue(true),
		Category("Appearance"),
		Description("Specifies whether or not to show a button panel.")
		]
		public bool ButtonPanelVisible
		{
			get
			{
				return this.buttonPanelVisible;
			}
			set
			{
				this.buttonPanelVisible = value;
				this.buttonPanel.Visible = this.buttonPanelVisible;
				if (buttonPanel.Visible)
				{
					buttonPanel.Size = new Size(this.Width, 40);
					notesDBG.Location = new Point(0, 40);
					notesDBG.Size = new Size(this.Width, this.Height - 40);
				}
				else
				{
					notesDBG.Location = new Point(0, 0);
					notesDBG.Size = this.Size;
				}
			}
		}

		/// <summary>
		/// Get the notes grid in the panel
		/// </summary>
		[Browsable(false)]
		public GridDataBoundGrid NotesGrid
		{
			get
			{
				return this.notesDBG;
			}
		}
		#endregion

		
		/// <summary>
		/// Overridden. See <see cref="System.Windows.Forms.Control.SetBoundsCore"/>.
		/// </summary>
		protected override void SetBoundsCore(int x, int y, int width, int height, BoundsSpecified specified)
		{
			base.SetBoundsCore(x, y, width, height, specified);
		}

		private void addNoteBT_Click(object sender, EventArgs e)
		{
			Console.WriteLine("Add Note loc = " + this.Location+", size=" + this.Size);
			this.ButtonPanelVisible = false;
		}
	}
}
